#
#  Test examples for xmlBlaster socket communication
#

import time, thread
from xb_socket import XBsession as XBS

HOST = 'dserv1'
PORT = 7607

UNIQUE = time.asctime()

def pubget():
    'publish/get example'
    xbs = XBS(HOST,PORT)
    xbs.ping()
    xbs.connect('pubget_'+UNIQUE,'xyz')
    xbs.publish('motd_'+UNIQUE,'Here is the news\npass')
    xbs.get('motd_'+UNIQUE)
    xbs.disconnect()

def connectcallback():
    'connect with callback'
    xbs = XBS(HOST,PORT)
    xbs.connectcb('conncb_'+UNIQUE,'xyz')
    xbs.subscribe('trivia_'+UNIQUE)
    xbs.publish('trivia_'+UNIQUE,'big fat cat')
    xbs.localupdate(ack=1)
    xbs.disconnect()

def connectcallback1way():
    'connect with callback'
    xbs = XBS(HOST,PORT)
    xbs.connectOneway('conncb_'+UNIQUE,'xyz')
    xbs.subscribe('trivia_'+UNIQUE)
    xbs.publish('trivia_'+UNIQUE,'monty python')
    xbs.localupdate()
    xbs.disconnect()

def remoteserver():
    'remote server thread'
    xbs = XBS(HOST,PORT)
    xbs.connectcb('rem_'+UNIQUE,'def')
    while 1:
        info = xbs.remoteupdate()
        if info == 'terminate':
            break
        infol = list(info)
        infol.reverse()
        xbs.publishptp('result_'+UNIQUE,''.join(infol),\
            'loc_'+UNIQUE)
    xbs.disconnect()

def localclient():
    'local client for ptp to remote server'
    xbs = XBS(HOST,PORT)
    xbs.connectcb('loc_'+UNIQUE,'abc')
    time.sleep(1)
    xbs.publishptp('task_'+UNIQUE,'1234567890','rem_'+UNIQUE)
    info = xbs.remoteupdate()
    xbs.publishptp('task_'+UNIQUE,'terminate','rem_'+UNIQUE)
    time.sleep(3)
    xbs.disconnect()

def rpc():
    thread.start_new_thread(remoteserver,())
    time.sleep(1)
    localclient()

# MAINLINE
print '''
    1   test publish/get
    2   test connect with callback
    3   test connect with oneway callback
    4   test remote procedure call
'''
test = raw_input('Enter number to test:')
if test == '1':
    pubget()                  # ok
elif test == '2':
    connectcallback()         # xmlBlaster logs warnings
elif test == '3':
    connectcallback1way()     # xmlBlaster logs errors
elif test == '4':
    rpc()                     # xmlBlaster logs errors
