
import socket
socket.setdefaulttimeout(30)

import TcpClient, zlib

conQos = '''
<qos>

   <securityService type="htpasswd" version="1.0">
     <![CDATA[
     <user>michele</user>
     <passwd>secret</passwd>
     ]]>
   </securityService>

   <session name='joe/3' timeout='3600000' maxSessions='10'
               clearSessions='false' reconnectSameClientOnly='false'/>

   <!-- Recoverable session after server crash / restart -->
   <persistent/>

   <ptp>true</ptp>

   <duplicateUpdates>false</duplicateUpdates>

   <queue relating='callback' maxEntries='1000' maxBytes='4000000'
                                                   onOverflow='deadMessage'>
      <callback type='IOR' sessionId='4e56890ghdFzj0' pingInterval='10000'
          retries='-1' delay='10000' oneway='false' dispatchPlugin='undef'>
         IOR:10000010033200000099000010....
         <burstMode collectTime='400' maxEntries='20' maxBytes='-1L' />
         <compress type='gzip' minSize='3000'/> 
         <ptp>cbrown</ptp>
      </callback>
   </queue>
   <!-- a client specific property: here it could be the bean to invoke on updates -->
   <clientProperty name='onMessageDefault'>beanName</clientProperty>

</qos>
'''

def encapsulate(s):
    return '%10d%s' % (len(s)+10,s)

def flag():
    cs = chr(0)
    cmprn = chr(0)
    type = 'I'
    null = chr(0)
    proto = '1'
    return ''.join([cs,cmprn,type,null,null,proto])

def reqID(rqid):
    return rqid + chr(0)

def method(mthd):
    return mthd + chr(0)

def sessID(sess):
    return sess + chr(0)

def lenUzip(luz):
    return luz + chr(0)

def userData(qos,key,content):
    return chr(0).join([qos,key,str(len(content)),content])

def chksum(cs):
    return cs

def msg(rqid,mthd,qos,oid,data):
    return ''.join([flag(),reqID(rqid),method(mthd),\
        sessID(''),lenUzip(''),\
        userData(qos,"<key oid='"+oid+"'/>",data),\
        chksum('')])

cli = TcpClient.skt('dserv1',7607)
cli.write(encapsulate(msg('1st','ping','','','')))
cli.read(4096)
cli.write(encapsulate(msg('2nd','connect',conQos,\
    'hello','Hello World')))
x = cli.read(4096)
print '\n'
print x.replace(chr(0),'*')

