
import socket
socket.setdefaulttimeout(30)

import TcpClient, zlib

conQos = '''<qos>
  <securityService type='htpasswd' version='1.0'>
    <user>colin1</user>
    <passwd>abcde1</passwd>
  </securityService>
</qos>'''

clrQos = '''<qos>
  <deleteSubjectQueue>true</deleteSubjectQueue>
  <clearSessions>false</clearSessions>
</qos>'''

callbackQos = '''<qos>
  <queue relating='callback' maxEntries='100' maxEntriesCache='100'>
    <callback type='SOCKET' sessionId='%s'>
      socket://%.120s:%d
    </callback>
  </queue>
</qos>'''

def encapsulate(s):
    return '%10d%s' % (len(s)+10,s)

def flag():
    cs = chr(0)
    cmprn = chr(0)
    type = 'I'
    null = chr(0)
    proto = '1'
    return ''.join([cs,cmprn,type,null,null,proto])

def reqID(rqid):
    return rqid + chr(0)

def method(mthd):
    return mthd + chr(0)

def sessID(sess):
    return sess + chr(0)

def lenUzip(luz):
    return luz + chr(0)

def userData(qos,key,content):
    return chr(0).join([qos,key,str(len(content)),content])

def chksum(cs):
    return cs

def msg(rqid,mthd,sess,qos,oid,data):
    return ''.join([flag(),reqID(rqid),method(mthd),\
        sessID(sess),lenUzip(''),\
        userData(qos,"<key oid='"+oid+"'/>",data),\
        chksum('')])

cli = TcpClient.skt('dserv1',7607)
#cli.write(encapsulate(msg('1st','ping','','','','')))
#cli.read(4096)
print
cli.write(encapsulate(msg('2nd','connect','',conQos,'','')))
x = cli.read(4096)
print '\n'
print x.replace(chr(0),'*')
sid = x.split("sessionId='",1)[1].split("'")[0]
print '\n',"'"+sid+"'"
print
cli.write(encapsulate(msg('3rd','publish',sid,'<qos/>',\
    "MyMessageOid' contentMime='text/plain",\
    'this is the data\nand line 2 thereof')))
cli.read(4096)
print
cli.write(encapsulate(msg('4th','get',sid,'<qos/>',\
    'MyMessageOid','')))
x = cli.read(4096)
print
cli.write(encapsulate(msg('5th','disconnect',sid,\
    clrQos,'','')))
x = cli.read(4096)
